apiVersion: tekton.dev/v1beta1
kind: Task
metadata:
  name: s3-upload
spec:
  description: Upload file to S3 storage
  params:
    - description: Bucket to do the upload to.
      name: bucket
      type: string
    - description: Path and object name in bucket where to write file.
      name: destination
      type: string
    - description: Filename (*.json and *.jsonl) to include in archive.
      name: filename
      type: string
    - description: Secret with credentials for S3.
      name: mc-host-secret-ref
      type: string
  steps:
    - env:
        - name: TEMP_DIRECTORY
          value: $(workspaces.archived_ads.path)
      envFrom:
        - configMapRef:
            name: historical-ads-importer-cm
        - secretRef:
            name: $(params.mc-host-secret-ref)
      image: "docker-images.jobtechdev.se/script-container/script-container:latest"
      name: s3-upload
      resources: {}
      script: |
        #!/usr/bin/env sh

        echo "Listing files in current directory ($(pwd))"
        ls -l

        echo "Target date: $(params.filename)"

        filename_json="$(params.filename).json"
        filename_jsonl="$(params.filename).jsonl"
        zip_filename="$(params.filename).zip"

        echo "Zipping file $zip_filename"
        zip "$zip_filename" "$filename_json" "$filename_jsonl"

        echo "Set alias for s3"
        mc alias set s3 "$S3_URL" "$S3_ACCESS_KEY" "$S3_SECRET_KEY"

        echo "Uploading to s3"
        year=$(echo $(params.filename) | cut -d "-" -f 1)
        month=$(echo $(params.filename) | cut -d "-" -f 2)
        mc cp "./$zip_filename" "s3/$(params.bucket)/$(params.destination)/$year/$month/$zip_filename"
      workingDir: $(workspaces.archived_ads.path)
  workspaces:
    - description: |
        The folder where we write the json files
        with archived ads to.
      name: archived_ads
      optional: true
